//
// vorbis extractor
// Copyright 2003 by 2510. All rights reserved.
//

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

int main(int argc,const char *argv[])
{
int			in_fd,out_fd;
char		*buffer;
const char	*fname;
char		fname_buffer[256];
int			buffersize = 1024 * 512;
int			copying = 0,fileid = 1;
int			total = 0;

	if((argc < 3) || (argc > 4))
	{
		printf("usage: VorbisExtractor <input filename> <output filename prefix> [buffer size in KB]\n");
		return -1;
	}
	if(argc == 4)
	{
		sscanf(argv[3],"%d",&buffersize);
		buffersize *= 1024;
	}
	in_fd = open(argv[1],O_RDONLY);
	if(in_fd == 1)
	{
		printf("can't open input file.\n");
		return -1;
	}
	fname = argv[2];
	
	lseek(in_fd,0,SEEK_SET);
	buffer = malloc(buffersize);
	while(1)
	{
	int		readsize;
	int			pos;
	char		*ptr;
	const int	overwrap = 0x1D + 6;
	
		readsize = read(in_fd,buffer,buffersize);
		if(readsize == buffersize)
			readsize -= overwrap;
		ptr = buffer;
		for(pos = 0;pos < readsize;pos ++)
		{
		char	*vorbisident = "vorbis";
		
			if(buffer[pos + 0] != 'O') continue;
			if(buffer[pos + 1] != 'g') continue;
			if(buffer[pos + 2] != 'g') continue;
			if(buffer[pos + 3] != 'S') continue;
			
			if(strncmp(buffer + pos + 0x1D,vorbisident,sizeof(vorbisident) - 1) != 0) continue;
			
			if(copying)
			{
				write(out_fd,ptr,buffer + pos - ptr);
				close(out_fd);
			}
			
			copying = 1;
			sprintf(fname_buffer,"%s%d.ogg",fname,fileid ++);
			out_fd = open(fname_buffer,O_CREAT | O_RDWR,0755);
			
			printf("found vorvis header at offset %d, fileid %d (segment %d, offset %d)\n",
				total + pos,fileid - 1,total / buffersize,pos);
			ptr = &buffer[pos];
		}
		if(copying)
			write(out_fd,ptr,buffer + readsize - ptr);
		if(readsize != buffersize - overwrap)
			break;
		lseek(in_fd,-overwrap,SEEK_CUR);
		total += readsize;
	}
	if(copying)
		close(out_fd);
	return 0;
}